#include <sstream>
#include <string>
#include <curl/curl.h>
#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;


struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};
};

Input
input_data(istream& in, bool prompt) {
    if (prompt==true){
    Input in;
    cerr << "Enter number count: ";
    cin >> in.number_count;

    vector<double> numbers(in.number_count);
    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++) {
        cin >> in.numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> in.bin_count;

    size_t max_count;
    in.max_count = 0;
    return in;
    }

    if (prompt==false){
    Input in;

    cin >> in.number_count;

    vector<double> numbers(in.number_count);
    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++) {
        cin >> in.numbers[i];
    }

    size_t bin_count;
    cin >> in.bin_count;

    size_t max_count;
    in.max_count = 0;
    return in;
    }
}


Input
download(const string& address) {
    stringstream buffer;
    CURL *curl = curl_easy_init();
    if(curl) {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl);
        if (res!=0){
            cout<<res;
            exit(1);
            }
        }
    curl_global_init(CURL_GLOBAL_ALL);
    return input_data(buffer, false);
}



int main(int argc, char* argv[])
{
     Input input;
    if (argc > 1) {
        input = download(argv[1]);
    } else {
        input = input_data(cin, true);
    }

    auto in = input_data(cin, true);
    const auto bins = make_histogram(in.numbers, in.bin_count, in.number_count, in.max_count);
    vector<double> test;
    show_histogram_svg(bins, in.max_count, in.bin_count, test);

    return 0;
}
